﻿function GetPluginSettings()
{
	return {
		"name":			"WeeGoo SDK",
		"id":			"WGSDK",
		"version":		"1.0",
		"description":	"WeeGoo Construct 2 SDK",
		"author":		"WeeGoo",
		"category":		"Monetisation",
		"type":			"object", 
		"rotatable":	false,
		"flags":		pf_singleglobal
	};
};


function getGameEvents(){

	return {
		"game-event-start":"Game Start: When the game begins.",
		"game-event-level-start":"Level Start: When a new level or stage begins.",
		"game-event-level-finished":"Level Finished: When a level or stage is successfully completed.",
		"game-event-level-failed":"Level Failed: When the player fails to complete a level or stage.",
		"game-event-life-lost":"Life Lost: When the player loses a life or health.",
		"game-event-game-pause":"Game pause: Show ads when players pause the game, such as in a pause menu or during a break.",
		"game-event-resume-game":"Resume Game: When the player resumes the game after pausing.",
		"game-event-game-over":"Game Over/defeat: When the player loses all lives or fails the game or experience a game over or defeat, and offer a chance to continue or restart.",
		"game-event-game-checkpoint":"Checkpoints: Display ads when players reach specific checkpoints or milestones in the game.",
		"game-event-game-tutorial":"Tutorial Event: When the player starts, progresses through, or completes a tutorial.",
		"game-event-game-iap":"In-Game Purchase: When the player makes a purchase within the game, such as buying currency, items, or power-ups.",
		"game-event-game-achievement-unblock":"Achievement Unlocked: When the player accomplishes a specific goal or task.",
		"game-event-game-countdown":"Time Event: When a timed event or countdown reaches a certain point or ends.",
		"game-event-game-daily-reward":"Daily rewards/login bonus: Display ads alongside daily rewards or login bonuses to incentivize players to return."
	};
}





//for midroll
AddCondition(0, 0, "When the WGSDK is loaded", "Ads", "When the WGSDK is loaded", "When the WGSDK is loaded.", "SdkLoaded");

//AddCondition(1, 0, "When ad starts", "Ads", "When ad starts", "When ad starts, pause/mute game", "AdIsRunning"); 
//AddCondition(2, 0, "When ad finishes", "Ads", "When ad finishes", "When ad finishes resume/unmute game", "AdIsFinished");

//for rewarded 
AddCondition(3, 0, "When reward ad is available", "Ads", "When reward ad is available", "When reward ad is available", "RewardReady");
AddCondition(4, 0, "When reward granted", "Ads", "When reward was granted", "When user watched enough ad to get reward, you should grant the user with promised reward", "RewardGranted");
AddCondition(5, 0, "When reward was canceled", "Ads", "When reward was canceled", "True if the reward was canceled.", "RewardCanceled");
AddCondition(6, 0, "When reward was closed", "Ads", "When reward was closed", "True if the reward was closed.", "RewardClosed");

// Actions - midrolll 
//AddAction(0, af_none, "Display ad", "Ads", "Make an ad request", "Request an ad to display.", "RequestAd");

// Actions - reward
AddAction(1, af_none, "Init rewarded ad", "Ads", "Initialize rewarded ad", "Initialize rewarded ad.", "InitRewardedAd");
AddAction(2, af_none, "Display rewarded ad", "Ads", "Display rewarded ad", "Display rewarded ad.", "DisplayRewardedAd");

//Actions - Game events
//AddComboParam('Option 1', 'Select an option:', 'Option 1');




var gameEvents =  getGameEvents();
Object.keys(gameEvents).forEach( function(i){
	AddComboParamOption(gameEvents[i]);
});


function getGameEventsValues( gameEvents ){

	var result = [];
	Object.keys(gameEvents).forEach( function(i){
		result.push(gameEvents[i]);
	});

}

AddComboParam('Option 2', 'Select an option:', getGameEventsValues(gameEvents));
AddAction(3, af_none, 'Game event', 'Ads', 'Game event', 'Send game event.', 'GameEvent');



ACESDone();

// Property grid properties for this plugin
var property_list = [];

// Called by IDE when a new object type is to be created
function CreateIDEObjectType()
{
	return new IDEObjectType();
};

// Class representing an object type in the IDE
function IDEObjectType()
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");
};

// Called by IDE when a new object instance of this type is to be created
IDEObjectType.prototype.CreateInstance = function(instance)
{
	return new IDEInstance(instance);
};

// Class representing an individual instance of an object in the IDE
function IDEInstance(instance, type)
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");

	// Save the constructor parameters
	this.instance = instance;
	this.type = type;

	// Set the default property values from the property table
	this.properties = {};

	for (var i = 0; i < property_list.length; i++)
		this.properties[property_list[i].name] = property_list[i].initial_value;

	// Plugin-specific variables
	this.just_inserted = false;
};

IDEInstance.prototype.OnCreate = function()
{
};

IDEInstance.prototype.OnInserted = function()
{
};

IDEInstance.prototype.OnDoubleClicked = function()
{
};

// Called by the IDE after a property has been changed
IDEInstance.prototype.OnPropertyChanged = function(property_name)
{
};

IDEInstance.prototype.OnRendererInit = function(renderer)
{
};

// Called to draw self in the editor
IDEInstance.prototype.Draw = function(renderer)
{
};

IDEInstance.prototype.OnRendererReleased = function(renderer)
{
};