﻿// ECMAScript 5 strict mode
"use strict";

const WEEGOO_URL = "https://afg.wgplayer.com/wgplayer.com/js/RkQDh8KWt62VoH09FPNYqA/2357995679/wgAds.js";

 
assert2(cr, "cr namespace not created");
assert2(cr.plugins_, "cr.plugins_ not created");

cr.plugins_.WGSDK = function(runtime)
{
	this.runtime = runtime;
};

(function (){
	
	var pluginProto = cr.plugins_.WGSDK.prototype;

	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};

	var typeProto = pluginProto.Type.prototype;

	typeProto.onCreate = function()
	{
	};

	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;

		this.sdkLoaded = false;
		this.sdkInited = false;
		this.canShowAds = false;

		this.adIsRunning = false;
		this.adIsFinished = false;

		this.rewardReady = false;
		this.rewardInited = false;

		this.rewardGranted = false;
		this.rewardCanceled = false;
		this.rewardClosed = false;

		this.rewardContext = null;
		this.rewardCallback = null;		

		this.gameEvents = [
			"game-event-start",
			"game-event-level-start",
			"game-event-level-finished",
			"game-event-level-failed",
			"game-event-life-lost",
			"game-event-game-pause",
			"game-event-resume-game",
			"game-event-game-over",
			"game-event-game-checkpoint",
			"game-event-game-tutorial",
			"game-event-game-iap",
			"game-event-game-achievement-unblock",
			"game-event-game-countdown",
			"game-event-game-daily-reward"
	
		  ];

	};

	var instanceProto = pluginProto.Instance.prototype;	


	// called whenever an instance is created
	instanceProto.onCreate = function()
	{		
		// Attach events
		var self = this;

		if ( typeof window["preroll"] !== "object" ){
			(function (d, s, id) {
			  var js, fjs = d.getElementsByTagName(s)[0];
			  if (d.getElementById(id)) return;
			  js = d.createElement(s);
			  js.id = id;
			  fjs.parentNode.insertBefore(js, fjs);
	  
			  js.addEventListener("load", function () {
				
				(function (d, s, id) {
				  var js,
					fjs = d.getElementsByTagName(s)[0];
				  if (d.getElementById(id)) return;
				  js = d.createElement(s);
				  js.id = id;
				  fjs.parentNode.insertBefore(js, fjs);
				  

				  js.addEventListener("load", function () {
					var wgSdkLib = setInterval(function(){
						try{
							this.sdkLoaded = true;
							this.canShowAds = true;
							this.WGSDK = window[window["preroll"]["config"]["loaderObjectName"]];							
							clearInterval( wgSdkLib );

							this.WGSDK.registerGameControls({                      
								"pause":PauseGame,
								"resume":SetAdEnded,
								"context":this
							});

						}catch(e){}
					}.bind(self), 1000);
				  }.bind(self));

				  js.src = WEEGOO_URL;
				})(document, "script", "wgplayer-library");

			  }.bind(self));
			  js.src = "https://afg.wgplayer.com/wgplayer.com/wgAds.iframe.conf.js";


			})(document, "script", "wgplayer-conf");
		  }else{
			var checkSdk = setInterval( function(){
				if( window[window["preroll"]["config"]["loaderObjectName"]] ){
				  this.sdkLoaded = true;
				  this.canShowAds = true;
				  this.WGSDK = window[window["preroll"]["config"]["loaderObjectName"]];
				  clearInterval(checkSdk);

				  this.WGSDK.registerGameControls({                      
					"pause":PauseGame,
					"resume":SetAdEnded,
					"context":this
				});


				}
			  }.bind(this), 100);
		  }	

	};
	
	
	function Cnds() {};

	//sdk loaded
	Cnds.prototype.SdkLoaded = function()
	{
		if( this.sdkLoaded === true ){
			this.sdkLoaded = false;
			this.canShowAds = true;
			return true;
		}
		return this.sdkLoaded;
	};


	/*
	//midroll
	Cnds.prototype.AdIsRunning = function()
	{
		if( this.adIsRunning === true ){
			this.adIsRunning = false;
			return true;
		}
		return false;
	};
	
	Cnds.prototype.AdIsFinished = function()
	{
		if( this.adIsFinished === true ){
			this.adIsFinished = false;
			return true;
		}
		return false;
	};
	*/

	//reward
	Cnds.prototype.RewardReady = function()
	{
		return this.rewardReady;
	};
	
	Cnds.prototype.RewardGranted = function()
	{
		if( this.rewardGranted === true ){
			this.rewardGranted = false;
			return true;
		}
		return this.rewardGranted;
	};

	Cnds.prototype.RewardCanceled = function()
	{
		if( this.rewardCanceled === true ){
			this.rewardCanceled = false;
			return true;
		}
		return this.rewardCanceled;
	};

	Cnds.prototype.RewardClosed = function()
	{ 
		if( this.rewardClosed === true ){
			this.rewardClosed = false;
			return true;
		}
		return this.rewardClosed;
	}

	pluginProto.cnds = new Cnds();

	function Acts() {};



	function SetAdEnded(){ 
		this.adIsRunning = false;
		this.adIsFinished = true; 
 
		this.runtime.setSuspended(false);

	} 

	/*
	Acts.prototype.RequestAd = function (){
		if ( ! this.canShowAds ) return;
		
		PauseGame();

        this.adIsRunning = true;
		this.WGSDK.refetchAd( [SetAdEnded, this] );
	};
	*/
	


	function OnRewardReadyCallback( callback, context, gameContext ){

		gameContext.rewardContext = context;
		gameContext.rewardCallback = callback;

		gameContext.rewardReady = true;
	}

	function onRewardCompleteCallback(payload, gameContext){
		gameContext.rewardGranted = true;
	}

	function onRewardCancelCallback(gameContext){
		gameContext.runtime.setSuspended(false);
		gameContext.rewardCanceled = true;			
	}

	function onRewardClosedCallback(gameContext){
		gameContext.runtime.setSuspended(false);
		gameContext.rewardClosed = true;
	}	

    function PauseGame(){
		this.runtime.setSuspended(true)
	}
  
	function ResumeGame(){
		this.runtime.setSuspended(false)
	}

	
	Acts.prototype.DisplayRewardedAd = function(){
		if( this.rewardCallback ){
			this.rewardCallback.call( this.rewardContext );
		}
	};

	Acts.prototype.InitRewardedAd = function(){
		if ( !this.canShowAds || this.rewardInited === true) return;

		this.WGSDK.registerRewardCallbacks({
			onReady:OnRewardReadyCallback, 
			onSuccess:onRewardCompleteCallback, 
			onFail:onRewardCancelCallback,
			onClose:onRewardClosedCallback,
			context:this
		});
		this.rewardInited = true;
	};



	Acts.prototype.ShowRewardAd = function(){
		if( ! this.rewardReady ){
			return false;
		}
		if( this.rewardCallback ){
			this.runtime.setSuspended(false);
			this.rewardCallback.call( this.rewardContext );
		}
	};

	 
	Acts.prototype.GameEvent = function( event ){

		this.WGSDK.GameEvent(this.gameEvents[event]);
	};
	


	pluginProto.acts = new Acts();

	function Exps() {};

	pluginProto.exps = new Exps();

}());